unit hiStrReverse;

interface

uses
  Share, Windows, KOL, Debug;

type
  ThiStrReverse = class(TDebug)
    private
      FResult: string;
    public
      _data_Str: THI_Event;
      _event_onResult: THI_Event;
      
      procedure _work_doReverse(var _Data: TData; Index: Word);
      procedure _var_Result(var _Data: TData; Index: Word);
  end;
  
  
  function StrReverse(const S: string): string;
  procedure BufReverse(Buf: Pointer; L: Integer); overload;
  procedure BufReverse(Src, Dst: Pointer; L: Integer); overload; // Src, Dst         
  
implementation

function StrReverse(const S: string): string;
var
  L: Integer;
  P: Pointer;
begin
  L := Length(S);
  SetLength(Result, L);
  P := Pointer(Result);
  for L := L downto 1 do
  begin
    Char(P^) := S[L];
    Inc(Integer(P));
  end;
end;

procedure BufReverse(Buf: Pointer; L: Integer);
var
  B: Byte;
  Buf2: PByte;
begin
  Buf2 := PByte(Integer(Buf) + L - 1);
  
  while Integer(Buf) < Integer(Buf2) do
  begin
    B := Byte(Buf^);
    Byte(Buf^) := Buf2^;
    Buf2^ := B;
    Inc(Integer(Buf));
    Dec(Buf2);
  end;
end;

procedure BufReverse(Src, Dst: Pointer; L: Integer);
begin
  Dst := Pointer(Integer(Dst) + L - 1);
  
  while L > 0 do
  begin
    Byte(Dst^) := Byte(Src^);
    Inc(Integer(Src));
    Dec(Integer(Dst));
    Dec(L);
  end;
end;

procedure ThiStrReverse._work_doReverse(var _Data: TData; Index: Word);
begin
  FResult := StrReverse(ReadString(_Data, _data_Str, ''));
  _hi_CreateEvent(_Data, @_event_onResult, FResult);
end;

procedure ThiStrReverse._var_Result(var _Data: TData; Index: Word);
begin
  dtString(_Data, FResult);
end;


end.